/*
tools.cpp 
(c) 2004 Arne Bartels arne.bartels@nwn.de
A bit of calculation code.
*/
#include	"tools.h"
#include	<math.h>
#ifndef	PI
	#define		PI			3.1415926535897932384626433832795		//circle number
#endif

#define		HALFEARTH	10800									//half earth circumference in nautic miles
#define		RADIANS_TO_DEGREE_FACTOR			(180.0/PI)
//#define		DEG_SIN( val )	sin( ( val )/RADIANS_TO_DEGREE_FACTOR)					//sinus in degrees
//#define		DEG_COS( val )	cos( ( val )/RADIANS_TO_DEGREE_FACTOR)					//cosine in degrees
//#define		DEG_TAN( val )	tan( ( val )/RADIANS_TO_DEGREE_FACTOR)					//tangens in degrees
//#define		DEG_ASIN( val )	RADIANS_TO_DEGREE_FACTOR * asin(( val ))				//arcsinus in degrees
//#define		DEG_ACOS( val )	RADIANS_TO_DEGREE_FACTOR * acos(( val ))				//arccosine in degrees
//#define		DEG_ATAN( val )	RADIANS_TO_DEGREE_FACTOR * atan(( val ))				//arctangens in degrees
//#define		DEG_ATAN2( val1 , val2 )	RADIANS_TO_DEGREE_FACTOR * atan2( val1, val2 )	//atan2 in degrees


#define		RADIANS_TO_MINUTE_FACTOR	(10800.0/PI)
#define		RADIANS_TO_MINUTE( val )	 (RADIANS_TO_MINUTE_FACTOR *( val ))

#define		MIN_SIN( val )	(sin( ( val )/RADIANS_TO_MINUTE_FACTOR))
#define		MIN_COS( val )	(cos( ( val )/RADIANS_TO_MINUTE_FACTOR))
#define		MIN_TAN( val )	(tan( ( val )/RADIANS_TO_MINUTE_FACTOR))
#define		MIN_ASIN( val )	(RADIANS_TO_MINUTE_FACTOR * asin(( val )))
#define		MIN_ACOS( val )	(RADIANS_TO_MINUTE_FACTOR * acos(( val )))
#define		MIN_ATAN( val )	(RADIANS_TO_MINUTE_FACTOR * atan(( val )))
#define		MIN_ATAN2( val1 , val2 )	(RADIANS_TO_MINUTE_FACTOR * atan2( ( val1) , ( val2 ) ))



/*         #if (_MSC_VER >= 1300) && (WINVER < 0x0500)
        //VC7 or later, building with pre-VC7 runtime libraries
        extern "C" long _ftol( double ); //defined by VC6 C libs
        extern "C" long _ftol2( double dblSource ) { return _ftol( dblSource ); }
        #endif
*/
//GREAT CIRCLE
//                                           _                                    
//                                         |  \
//                                       To|   |InboundCourse
//  ---------------------------------------+----
//         |                             / |   |
//         |                           /\  |  / beta
//         |                         /    -|- 
//         |                       /       .
//         |                     /         .
//         |                   /           .
//         |                 /             .
// DeltaTheta              / Dist          .
//         |             /                 .
//         |           /                   .
//         |         /                     .
//         |  alpha/                       .
//         |-----/                         .
//         |   /                           .
//        \|//                             .
//    -----+------------DeltaPhi---------->.
//         |From
//         |
//         |
//

double	GrtCrcDist(double	*pdblInboundCourse,
					  double	dblFromLat,double	dblFromLong,
					  double	dblToLat,double	dblToLong)
// input  (lat,lon)  in degrees
// output (dist,crs) in minutes (==nm)
{
	double	dblDist=0,dblCourse=180,dblDeltaTheta=0,dblDeltaPhi=0;

	dblDeltaPhi=(dblToLong-dblFromLong)*0.5;
	dblDeltaTheta=(dblToLat-dblFromLat)*0.5;
	dblDist=	DEG_SIN(dblDeltaTheta)*DEG_SIN(dblDeltaTheta)+
				DEG_COS(dblFromLat)*DEG_COS(dblToLat)*DEG_SIN(dblDeltaPhi)*DEG_SIN(dblDeltaPhi);
	if(dblDist>0)
	{
		dblDist=sqrt(dblDist);
		if(dblDist<1)
			dblDist=2*MIN_ASIN(dblDist);
		else
			dblDist=HALFEARTH;
		dblCourse=DEG_ACOS(
			(DEG_SIN(dblFromLat)-DEG_SIN(dblToLat)*MIN_COS(dblDist))/
			(DEG_COS(dblToLat)*MIN_SIN(dblDist))
						);
	}
	if(DEG_SIN(2.0*dblDeltaPhi)>0)
		dblCourse=360-dblCourse;
	*pdblInboundCourse=dblCourse;
	return	dblDist;
}
